import * as Util from '../util/all';
declare enum TokType {
    Text = 0,
    OpenParen = 1,
    CloseParen = 2,
    Not = 3,
    And = 4,
    Or = 5,
    Colon = 6,
    GreaterThan = 7,
    GreaterThanEqual = 8,
    Equal = 9,
    LessThan = 10,
    LessThanEqual = 11,
    NotEqual = 12
}
interface Token {
    tt: TokType;
    text?: string;
}
interface Clause {
    op: Token;
    operand1?: Clause;
    operand2?: Clause;
}
declare class Lexer {
    coder: Util.Coder;
    tokens: Token[];
    buf: Uint8Array;
    tok: Uint8Array;
    toklen: number;
    n: number;
    constructor(coder: Util.Coder, expr?: string);
    set(expr: string): void;
    pushString(s: string): void;
    pushText(bForce?: boolean): void;
    pushSpecial(tt: TokType): void;
    lex(): void;
}
declare class Parser {
    clauses: Clause[];
    constructor();
    get clause(): Clause;
    initFromTokens(tokens: Token[]): void;
    initFromClauses(clauses: Clause[]): void;
    convertOpToText(): void;
    combineParenthetical(): void;
    combineUnary(): void;
    combineColon(): void;
    combineBinary(tt: TokType): void;
    combineImplicitAnd(): void;
    clausesFromTokens(tokens: Token[]): void;
}
export declare class FilterExpr {
    lexer: Lexer;
    parser: Parser;
    constructor(coder: Util.Coder, expr?: string);
    set(expr: string): void;
    test(o: any, types?: any): boolean;
    asString(): string;
    containsClause(expr: string): boolean;
    addClause(expr: string): void;
    removeClause(expr: string): void;
    asStringClause(clause: Clause): string;
    testClause(o: any, types: any, clause: Clause, prop?: string, relation?: TokType): boolean;
}
export {};
