export declare type Matrix = number[][];
export declare type Vector = number[];
export declare type Range = number[];
export declare type Index = number[][];
export declare type applyCB = (v: Vector) => number;
export declare const enum Dim {
    Rows = 0,
    Columns = 1
}
export declare function matrix(a: Matrix): Matrix;
export declare function multiply(a: Matrix, b: Matrix): Matrix;
export declare function transpose(a: Matrix): Matrix;
export declare function apply(a: Matrix, over: Dim, cb: applyCB): Vector;
export declare function min(v: Vector): number;
export declare function max(v: Vector): number;
export declare function concat(a: Matrix, b: Matrix, by: Dim): Matrix;
export declare function row(a: Matrix, i: number): Vector;
export declare function column(a: Matrix, j: number): Vector;
export declare function subtract(a: Vector, b: Vector): Vector;
export declare function dotMultiply(a: Vector, b: Vector): Vector;
export declare function index(a: Range, b: Range): Index;
export declare function range(start: number, end: number, includeEnd?: boolean): Vector;
export declare function subset(a: Matrix, select: Index): Matrix;
export declare function dotProduct(a: Vector, b: Vector): number;
