import * as PP from './polypack';
export interface TickOptions {
    maxLeafCount?: number;
    maxDepth?: number;
    tickStep?: number;
}
export declare const DefaultTickOptions: {
    maxLeafCount: number;
    maxDepth: number;
    tickStep: number;
};
export declare const EARTH_RADIUS = 6371000;
export interface PolyOptions {
    noLatitudeCorrection?: boolean;
}
export declare const DefaultOptions: PolyOptions;
export declare function polySimpleArea(b: Float64Array, iOffset: number, n: number): number;
export declare function polyNormalize(poly: any): PP.PolyPack;
export declare function polyNull(poly: any): boolean;
export declare function polyArea(poly: any): number;
export declare function polyDiameter(poly: any, options?: PolyOptions): number;
export declare function polyPerimeter(poly: any, options?: PolyOptions): number;
export declare class Circle {
    x: number;
    y: number;
    r: number;
    constructor(x: number, y: number, r: number);
}
export declare function polyToCircle(poly: any): Circle | null;
export declare function polyToPolsbyPopperCircle(poly: any, options?: PolyOptions): Circle | null;
export declare function polyFromCircle(c: Circle, nSegments?: number): any;
export declare function polyToExteriorPoints(poly: any): any;
export declare function polyConvexHull(poly: any, altAlgorithm?: any): any;
export declare function makeConvexHullMonotoneChain2D(poly: any): any;
export interface CompactnessDescription {
    value: number;
    reock: number;
    polsby_popper: number;
    convex_hull: number;
    schwartzberg: number;
}
export declare function polyCompactness(poly: any, options?: PolyOptions): CompactnessDescription;
export interface PolyDescription {
    npoly: number;
    nhole: number;
    npoint: number;
}
export declare function polyDescribe(poly: any): PolyDescription;
export declare function npoints(poly: any): number;
export declare function polyTransform(poly: any, transformFn: any): any;
export interface RewindOptions {
    validateHoles?: boolean;
    validateClose?: boolean;
    canonical?: boolean;
}
interface Winding {
    iPoly: number;
    iRing: number;
    direction: number;
}
export declare function polyRingWindings(poly: any): Winding[];
export declare function featureRewind(f: any, options?: RewindOptions): any;
export declare function polyRewindRings(pp: any, bLog?: boolean): any;
export declare function polyBadCoordinates(f: any): boolean;
export {};
