import * as FSM from '../fsm/all';
import * as Poly from './poly';
import * as BB from './boundbox';
export interface WrappedPoly {
    f: any;
    box: BB.BoundBox;
    p: any;
}
export interface WorkDone {
    nUnion: number;
    nDifference: number;
    ms: number;
}
export declare function unionPolys(polys: any[]): any;
export interface QuadOptions {
    maxLeafCount?: number;
    maxDepth?: number;
    tickStep?: number;
}
export declare const DefaultQuadOptions: QuadOptions;
export interface TickCounter {
    ticks: number;
}
declare class QuadLevel {
    options: QuadOptions;
    level: number;
    children: QuadLevel[];
    features: WrappedPoly[];
    box: BB.BoundBox;
    asyncUnion: any;
    constructor(options: QuadOptions, level: number, box: BB.BoundBox, features: WrappedPoly[]);
    private featureInBox;
    featureUnderCoord(coord: [number, number]): any;
    union(): any;
    get isempty(): boolean;
    tickUnion(tickCounter: TickCounter): void;
}
export declare class FsmQuadTree extends FSM.Fsm {
    quad: QuadLevel;
    asyncUnion: any;
    isempty: boolean;
    options: Poly.TickOptions;
    work: WorkDone;
    constructor(env: FSM.FsmEnvironment, options?: Poly.TickOptions, col?: any);
    initialize(col: any): void;
    cancel(): any;
    get result(): any;
    tick(): void;
}
export {};
