import * as FSM from '../fsm/all';
import * as P from './poly';
import * as Q from './quad';
export declare type Topo = any;
export declare function topoFromCollection(col: any): Topo;
export declare function topoContiguity(topo: Topo): any;
export declare function topoToFeature(topo: Topo, geoid: string): any;
export declare function topoToCollection(topo: Topo): any;
export interface SimplifyOptions {
    minArea?: number;
    log?: boolean;
}
export declare function topoSimplifyCollection(col: any, options?: SimplifyOptions): any;
export declare function topoMerge(topo: Topo, geoids: string[]): any;
export declare function topoMergeFeatures(topo: Topo, features: any[]): any;
declare class FsmIncrementalUnion extends FSM.Fsm {
    options: P.TickOptions;
    key: any;
    map: any;
    result: any;
    work: Q.WorkDone;
    constructor(env: FSM.FsmEnvironment, options: P.TickOptions, key: any, map?: any);
    matches(key: any): boolean;
    recompute(map: any): void;
    cancel(): void;
    tick(): void;
}
export interface TopoUnionResult {
    key: any;
    poly: any;
    work: Q.WorkDone;
}
export declare class FsmTopoUnion extends FSM.Fsm {
    options: P.TickOptions;
    unions: FsmIncrementalUnion[];
    work: Q.WorkDone;
    constructor(env: FSM.FsmEnvironment, options?: P.TickOptions);
    get result(): TopoUnionResult[];
    cancel(): void;
    cancelOne(key: any): void;
    recompute(key: any, map: any): void;
    tick(): void;
}
export declare function topoPacked(topo: any): boolean;
export declare function topoPack(topo: any): any;
export declare function topoUnpack(topo: any): any;
export {};
