export declare type DateString = string;
export declare function Now(): DateString;
export declare class Elapsed {
    tStart: any;
    tDur: any;
    constructor(bStart?: boolean);
    start(): void;
    end(): void;
    ms(): number;
    nano(): number;
}
export declare class MultiTimer {
    _overall: Elapsed;
    _segment: Elapsed;
    _msAggregate: number;
    constructor(bStart?: boolean);
    start(): void;
    end(): number;
    segstart(): void;
    segend(): number;
    get overall(): number;
    get aggregate(): number;
}
export declare class Deadline {
    msDelta: number;
    elapsed: Elapsed;
    constructor(msDelta: number);
    start(): void;
    done(): boolean;
}
export declare function createGuid(): string;
export declare function sizeof(a: any): number;
export declare function depthof(a: any): number;
export declare function isEmpty(o: any): boolean;
export declare function countKeys(o: any): number;
export declare function nthProperty(o: any, n?: number): any;
export declare function nthKey(o: any, n?: number): any;
export declare function partialEqual(o: any, subset: any): boolean;
export interface EqOptions {
    omitKey?: {
        [key: string]: boolean;
    };
    unorderedArrays?: boolean;
    emptyStringIsNull?: boolean;
    epsilon?: number;
}
export declare function deepEqual(o1: any, o2: any, options?: EqOptions): boolean;
export declare function prettyDate(d: Date): string;
export declare function relativeDate(d: Date): string;
export declare function recentDate(d: Date): string;
export declare function textToHtml(sText: string): string;
export declare function shallowCopy(src: any): any;
export declare function shallowAssign(o1: any, o2: any): any;
export declare function shallowDelete(o1: any, o2: any): any;
export declare function shallowAssignImmutable(o1: any, o2: any): any;
export declare function shallowEqual(o1: any, o2: any): boolean;
export declare function deepCopy(src: any): any;
export declare function deepAccum(accum: any, o: any): any;
export declare function precisionRound(n: number, p: number): number;
export declare function percentString(num: number, den: number, precision?: number): string;
export declare function hash(s: string): number;
export declare function hashObject(o: any): number;
export declare function toHex(n: number): string;
export declare function toRGBA(color: string, alpha: number): string;
export declare function toRGBAIntensity(color: string, intensity: number, alpha: number): string;
export declare function distance(x0: number, y0: number, x1: number, y1: number): number;
export declare function deg2rad(num: number): number;
export declare function rad2deg(num: number): number;
export declare function wrapLon(lon: number): number;
